/*
               ____   ______ __  ___ ____ ____         __ __ __
              / __ \ / ____//  |/  //  _// __ \   ____/ // // /
             / / / // __/  / /|_/ / / / / / / /  / __  // // /
            / /_/ // /___ / /  / /_/ / / /_/ /_ / /_/ // // /
           /_____//_____//_/  /_//___//_____/(_)\__,_//_//_/

         Dll Europenne de Manipulation d'Images et de Dialogues


                                                           De Bub325
														( bub325@ifrance.com )


Necessite la bibliothque BMGlib pour la gestion des diffrents formats d'images.
*/


#include <windows.h>

#include "../BMGUtils.h"
#include "../BMGDLL.h"

#define MFUNC(x) int WINAPI x (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause)
#define ret(x) { lstrcpy(data,x); return 3; }


//Variable globale:
LPSTR			mData;					//file mapped memory
HANDLE			hFileMap;				//file mapping object

int				DlgNbr;

//Donne fournises par mIrc  l'amorage de la dll
typedef struct
{
DWORD  mVersion;
HWND   mHwnd;
BOOL   mKeep;
} LOADINFO;

LOADINFO loadInfo;


//Structure des dialogues
struct DEMID
{
	bool topic;
	bool dlgUsed;
	char dlgName[0xFF];
	HWND dlgHwnd;
	char BkImg[0xFF];
	char TransparentImg[0xFF];
	bool clkMove;
	bool dlgparent;
	int TopXposition;
	int TopXpixel;
	int TopYposition;
	int TopYpixel;
	int ButtomXposition;
	int ButtomXpixel;
	int ButtomYposition;
	int ButtomYpixel;
	HWND parent;
	WNDPROC procParent;
	WNDPROC procDlg;
	HBITMAP img;
};
//65535 dialog possible
struct DEMID demid[0xFF];

//structure des zones de transparences
//Structure des dialogues
struct TransZone
{
	bool used;
	char img[0xFF];
	HRGN zone;
};
struct TransZone Zone[0xFF];

//Vrification si le dialog est dj enregistr
int dlgFind(HWND hWnd)
{
	int i,j;
	i = 0;
	j = 0;

	while ((demid[i].dlgHwnd != hWnd) && (i < 0xFF) && (j != DlgNbr)) {
		if (demid[i].dlgUsed) j++;
		i++;
	}

	if ((i == 0xFF) || (j == DlgNbr)) return -1;
	return i;
}

//Recherche d'un emplacement vide.
int dlgLibre()
{
	int i;
	i = 0;

	while ((demid[i].dlgUsed) && (i < 0xFF)) i++;

	if (i == 0xFF) return -1;
	return i;
}

//Vrification si l'image est dj enregistre
int FindZone(LPSTR image,bool FORCE = false)
{
	int i;
	i = 0;

	while ((Zone[i].used) && (lstrcmpi(Zone[i].img,image) != 0) && (i < 0xFF)) i++;

	if (((Zone[i].used) || (FORCE)) && (i < 0xFF)) return i;
	else return -1;
}

bool ReadIMG(LPSTR image, BMGImageStruct *bmp)
{
	//creation de la structure d'image
	OFSTRUCT file;
	if (OpenFile(image,(OFSTRUCT FAR*)&file,OF_EXIST) == HFILE_ERROR) return false;
	else return (ReadPNG(image,bmp) == 0);
}


//Gestion des evnement des dialog
LRESULT CALLBACK procDlg(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	LRESULT result;
	//recherche a quel dialog correspond ce proc
	int hDlg;
	hDlg = dlgFind(hwnd);

	switch (uMsg)
	{
	case WM_CLOSE:
		result = CallWindowProc(demid[hDlg].procDlg,hwnd,uMsg,wParam,lParam);
		if (demid[hDlg].BkImg[0] != NULL) {
			DeleteObject(demid[hDlg].img);
			lstrcpy(demid[hDlg].BkImg,"");
		}
		demid[hDlg].dlgUsed = false;
		demid[hDlg].topic = true;
		demid[hDlg].clkMove = false;
		demid[hDlg].dlgparent = false;
		demid[hDlg].procDlg = (WNDPROC)0;
		if (demid[hDlg].TransparentImg[0] != NULL) lstrcpy(demid[hDlg].TransparentImg,"");
		DlgNbr--;
		break;
/*
	case WM_ERASEBKGND:
		if (demid[hDlg].BkImg[0] != NULL)
		{
			SendMessage(hwnd,WM_PAINT,0,0);
			result = 0;
			break;
		}
*/
	case WM_ACTIVATE:
		if (demid[hDlg].dlgparent) {
			if (LOWORD(wParam) == WA_ACTIVE) {
				//Ne prend pas le focus pour le laisser a mIRC
				result = CallWindowProc(demid[hDlg].procDlg,hwnd,uMsg,wParam,lParam);
				SetActiveWindow(GetParent(hwnd));
				break;
			}
		}

	case WM_ERASEBKGND:
		if (demid[hDlg].BkImg[0] != NULL)
		{
			result = CallWindowProc(demid[hDlg].procDlg,hwnd,uMsg,wParam,lParam);
			//Dessine l'image en fond du dialog
			HDC hdc;
//			if (demid[hDlg].topic) hdc = GetDC(hwnd);
//			else hdc = GetWindowDC(hwnd);
			hdc = (HDC) wParam;
			HDC hdcBmp; 
			hdcBmp = CreateCompatibleDC(hdc); 
			SelectObject(hdcBmp, demid[hDlg].img);

//			HWND control;
//			control = FindWindowEx(hwnd,NULL,NULL,NULL);

			RECT dlgRECT/*,controlRECT*/;
			GetWindowRect(hwnd,&dlgRECT);

			int x,y;

			if (demid[hDlg].topic) {
				RECT clientRECT;
				GetClientRect(hwnd,&clientRECT);

				x = ((dlgRECT.right - dlgRECT.left) - (clientRECT.right - clientRECT.left)) / 2;
				y = - ((dlgRECT.bottom - dlgRECT.top) - (clientRECT.bottom - clientRECT.top)) + x;
				x = -3;
//				y = -3;
			}
			else {
				x = -3;
				y = -3;
			}

			BitBlt(hdc,x, y, dlgRECT.right - dlgRECT.left - 3, dlgRECT.bottom - dlgRECT.top - 3, hdcBmp, 0,0, SRCCOPY);

			ReleaseDC(hwnd,hdc);
			DeleteDC(hdcBmp);
			DeleteDC(hdc);
//			SendMessage(hwnd,WM_PAINT,0,0);
			break;
		}

	case WM_LBUTTONDOWN:
		//permet de dplacer le dialog lors d'un click gauche
		if (demid[hDlg].clkMove) {
			HRGN dlgRect;
			dlgRect = CreateRectRgn(0,0,0,0);
			GetWindowRgn(hwnd,dlgRect);
			POINT point;
			GetCursorPos(&point);
			MapWindowPoints(HWND_DESKTOP,hwnd,&point,1);
			if (PtInRegion(dlgRect,point.x,point.y)) {
				HWND ctrect;
				ctrect = FindWindowEx(hwnd,NULL,NULL,NULL);
				while (ctrect != NULL) 
				{
					RECT rectControl;
					GetWindowRect(ctrect,&rectControl);
					if (PtInRect(&rectControl,point)) return CallWindowProc(demid[hDlg].procDlg,hwnd,uMsg,wParam,lParam); 
					ctrect = FindWindowEx(hwnd,ctrect,NULL,NULL);
				}

				PostMessage (hwnd, WM_NCLBUTTONDOWN, HTCAPTION, lParam); 
			}
			DeleteObject(dlgRect);
		}

	//par dfault, redonne la main a mIrc pour la gestion du dialog
	default:
		result = CallWindowProc(demid[hDlg].procDlg,hwnd,uMsg,wParam,lParam);
	}
	return result;
}

bool ZoneTrans(LPSTR image, HRGN *rgn) 
{
	HDC hdc;
	hdc = GetWindowDC(loadInfo.mHwnd);

	//creation de la structure d'image
	BMGImageStruct bmp;
	HBITMAP m_img;
	if (!ReadIMG(image,&bmp)) return false;

	m_img = CreateBitmapFromData(bmp,0);
	GetDataFromBitmap(m_img,&bmp,0);

	HDC hdcBmp; 
	hdcBmp = CreateCompatibleDC(hdc); 
	SelectObject(hdcBmp, m_img);

	*rgn = CreateRectRgn(0,0,bmp.width,bmp.height);

	UINT x=0,y=0;
	while (x <= bmp.width) {
		while (y <= bmp.height) {
			if (GetPixel(hdcBmp,x,y) == RGB(255,0,255)) {
				HRGN tmpRGN;
				tmpRGN = CreateRectRgn(x,y,x+1,y+1);

				CombineRgn(*rgn,*rgn,tmpRGN,RGN_XOR);
				DeleteObject(tmpRGN);

			}
			y++;
		}
		x++;
		y=0;
	}

	DeleteDC(hdc);
	DeleteDC(hdcBmp);

	DeleteObject(rgn);

	return true;
}
	
extern "C"
{
	void WINAPI LoadDll(LOADINFO *li)
	{
		//create file mapping
		hFileMap = CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,0x4000,"mIRC");
		mData = (LPSTR)MapViewOfFile(hFileMap,FILE_MAP_ALL_ACCESS,0,0,0);

		loadInfo.mHwnd = li->mHwnd;
		loadInfo.mKeep = li->mKeep;
		loadInfo.mVersion = li->mVersion;

		int NbrDlg;
		NbrDlg = 0;
		while (NbrDlg != 0xFF) {
			demid[NbrDlg].dlgUsed = false;
			demid[NbrDlg].topic = true;
			demid[NbrDlg].clkMove = false;
			demid[NbrDlg].dlgparent = false;
			demid[NbrDlg].procDlg = (WNDPROC)0;
			NbrDlg++;
		}

		NbrDlg = 0;
		while (NbrDlg != 0xFF) Zone[NbrDlg++].used = false;

		DlgNbr = 0;
	}
	int WINAPI UnloadDll(int mTimeout)
	{
      if (!mTimeout)
      {
			//close file mapping
			UnmapViewOfFile(mData);
			CloseHandle(hFileMap);

			int zone;
			zone = 0;
			while (Zone[zone].used) DeleteObject(Zone[zone++].zone);
			
			zone = 0;
			while (zone != 0xFF) {
				if (demid[zone].dlgUsed) DeleteObject(demid[zone].img);
				zone++;
			}

      }
      return 0;   //dont unload me!!!
	}

	MFUNC(SetDlgTransparent)
	{
		char DlgName[0xFF],img[0xFF];
		int j = 0,i = 0;
		while (((int)data[i] != 32) && ((int)data[i] != NULL))
		{
			DlgName[j] = data[i];
			i++;
			j++;
		}
		DlgName[i] = NULL;

		if ((int)data[i] != NULL) i++;
		j = 0;
		while ((int)data[i] != NULL)
		{
			img[j] = data[i];
			j++;
			i++;
		}
		img[j] = NULL;

		wsprintf(mData,"$dialog(%s).hwnd",DlgName);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		HWND m_dialog;
		m_dialog = (HWND)atol(mData);

		int m_NbrDlg;
		m_NbrDlg = dlgFind(m_dialog);

		if (m_NbrDlg == -1) {
			m_NbrDlg = dlgLibre();
			if (m_NbrDlg == -1) ret("MAXIMUM_LIMIT");
			demid[m_NbrDlg].dlgHwnd = m_dialog;
			demid[m_NbrDlg].dlgUsed = true;
			DlgNbr++;
		}

		if ((int)img[0] == NULL) {
			lstrcpy(demid[m_NbrDlg].TransparentImg,"");				

			SetWindowRgn(m_dialog,NULL,true);
			ret("S_OK");
		}

		int FZone;
		FZone = FindZone(img);
		if (FZone == -1) {
			HRGN ZoneINV;
			if (!ZoneTrans(img,&ZoneINV)) ret("IMAGE_NOT_LOAD");
			SetWindowRgn(m_dialog,ZoneINV,true);
			DeleteObject(ZoneINV);
		}
		else {
			SetWindowRgn(m_dialog,Zone[FZone].zone,true);
			DeleteObject(Zone[FZone].zone);

			Zone[FZone].zone = CreateRectRgn(0,0,0,0);
			GetWindowRgn(m_dialog,Zone[FZone].zone);
		}

		lstrcpy(demid[m_NbrDlg].TransparentImg,img);

		if ((long)demid[m_NbrDlg].procDlg == 0) demid[m_NbrDlg].procDlg = (WNDPROC)SetWindowLong(m_dialog,GWL_WNDPROC,(long)procDlg);

		ret("S_OK");
	}
	MFUNC(GetDlgTransparent)
	{
		if ((int)data[0] == NULL) ret("S_ERROR");

		//rcupration du HWND a partir du nom du dialog
		wsprintf(mData,"$dialog(%s).hwnd",data);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		int m_NbrDlg;
		m_NbrDlg = dlgFind((HWND)atol(mData));

		if (m_NbrDlg == -1) ret("");
		ret(demid[m_NbrDlg].TransparentImg);
	}

	MFUNC(SetZoneTransparent)
	{
		int FZone;
		FZone = FindZone(data);
		if (FZone = -1) {
			FZone = FindZone(data,true);
			if (FZone == -1) ret("MAXIMUM_LIMIT");
			Zone[FZone].used = true;
			lstrcpy(Zone[FZone].img,data);
		}
		else {
			DeleteObject(Zone[FZone].zone);
		}
		if (!ZoneTrans(data,&Zone[FZone].zone)) ret("IMAGE_NOT_LOAD");

		ret("S_OK");
	}
	MFUNC(GetZoneTransparent)
	{
		if (FindZone(data) == -1) ret("$false");
		ret("$true");
	}

	MFUNC(SetBkImage)
	{
		char DlgName[0xFF],img[0xFF];
		int j = 0,i = 0;
		while (((int)data[i] != 32) && ((int)data[i] != NULL))
		{
			DlgName[j] = data[i];
			i++;
			j++;
		}
		DlgName[i] = NULL;

		if ((int)data[i] != NULL) i++;
		j = 0;
		while ((int)data[i] != NULL)
		{
			img[j] = data[i];
			j++;
			i++;
		}
		img[j] = NULL;

		wsprintf(mData,"$dialog(%s).hwnd",DlgName);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		HWND m_dialog;
		m_dialog = (HWND)atol(mData);

		int m_NbrDlg;
		m_NbrDlg = dlgFind(m_dialog);

		if (m_NbrDlg == -1) {
			m_NbrDlg = dlgLibre();
			if (m_NbrDlg == -1) ret("MAXIMUM_LIMIT");
			demid[m_NbrDlg].dlgHwnd = m_dialog;
			demid[m_NbrDlg].dlgUsed = true;
			DlgNbr++;
		}

		if ((int)img[0] == NULL) {
			lstrcpy(demid[m_NbrDlg].BkImg,"");				
			DeleteObject(demid[m_NbrDlg].img);

			ret("S_OK");
		}

		BMGImageStruct bmp;
		if (!ReadIMG(img,&bmp)) ret("IMAGE_NOT_LOAD");

		demid[m_NbrDlg].img = CreateBitmapFromData(bmp,0);
		GetDataFromBitmap(demid[m_NbrDlg].img,&bmp,0);

		lstrcpy(demid[m_NbrDlg].BkImg,img);

		if ((long)demid[m_NbrDlg].procDlg == 0) demid[m_NbrDlg].procDlg = (WNDPROC)SetWindowLong(m_dialog,GWL_WNDPROC,(long)procDlg);

		HDC fond;
		fond = GetDC(m_dialog);
		SendMessage(m_dialog,WM_ERASEBKGND,(UINT)fond,0);
//		SendMessage(m_dialog,WM_PAINT,0,0);

		DeleteDC(fond);

		HWND control;
		control = FindWindowEx(m_dialog,NULL,NULL,NULL);
					//Rafraichissement des controls pour viter qu'ils passent sous l'image
			while (control != NULL) {
//				GetWindowRect(control,&controlRECT);
				InvalidateRect(control,NULL,false);
//				HDC HDCct;
//				HDCct = GetWindowDC(control);
//				BitBlt(hdcBmp,controlRECT.left - dlgRECT.left - x/2, controlRECT.top - dlgRECT.top - y + x/2, controlRECT.right - controlRECT.left, controlRECT.bottom - controlRECT.top, HDCct, 0,0, SRCCOPY);

//				DeleteDC(HDCct);

				control = FindWindowEx(m_dialog,control,NULL,NULL);
			}
		ret("S_OK");
	}
	MFUNC(GetBkImage)
	{
		if ((int)data[0] == NULL) ret("DATA_ERROR");

		//rcupration du HWND a partir du nom du dialog
		wsprintf(mData,"$dialog(%s).hwnd",data);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		int m_NbrDlg;
		m_NbrDlg = dlgFind((HWND)atol(mData));

		if (m_NbrDlg == -1) ret("");
		ret(demid[m_NbrDlg].BkImg);
	}

	MFUNC(SetTopic)
	{
		wsprintf(mData,"$dialog(%s).hwnd",data);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		HWND m_dialog;
		m_dialog = (HWND)atol(mData);

		int m_NbrDlg;
		m_NbrDlg = dlgFind(m_dialog);

		if (m_NbrDlg == -1) {
			m_NbrDlg = dlgLibre();
			if (m_NbrDlg == -1) ret("MAXIMUM_LIMIT");
			demid[m_NbrDlg].dlgHwnd = m_dialog;
			demid[m_NbrDlg].dlgUsed = true;
			DlgNbr++;
		}

		demid[m_NbrDlg].topic = false;

		//suprime la barre de titre
		SetWindowLong(m_dialog,GWL_STYLE,GetWindowLong(m_dialog,GWL_STYLE) &~ WS_CAPTION);

		RECT rect;
		GetClientRect(m_dialog,&rect);

		HRGN rgn;
		rgn = CreateRectRgn(0,0,rect.right,rect.bottom);
		GetWindowRgn(m_dialog,rgn);
		SetWindowRgn(m_dialog,rgn,true);
		DeleteObject(rgn);

		if ((long)demid[m_NbrDlg].procDlg == 0) demid[m_NbrDlg].procDlg = (WNDPROC)SetWindowLong(m_dialog,GWL_WNDPROC,(long)procDlg);

		ret("S_OK");
	}
	MFUNC(GetTopic)
	{
		if ((int)data[0] == NULL) ret("DATA_ERROR");

		//rcupration du HWND a partir du nom du dialog
		wsprintf(mData,"$dialog(%s).hwnd",data);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		int m_NbrDlg;
		m_NbrDlg = dlgFind((HWND)atol(mData));

		if ((m_NbrDlg == -1) || (demid[m_NbrDlg].topic)) ret("$true");
		ret("$false");
	}

	MFUNC(SetClkMove)
	{
		wsprintf(mData,"$dialog(%s).hwnd",data);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		HWND m_dialog;
		m_dialog = (HWND)atol(mData);

		int m_NbrDlg;
		m_NbrDlg = dlgFind(m_dialog);

		if (m_NbrDlg == -1) {
			m_NbrDlg = dlgLibre();
			if (m_NbrDlg == -1) ret("MAXIMUM_LIMIT");
			demid[m_NbrDlg].dlgHwnd = m_dialog;
			demid[m_NbrDlg].dlgUsed = true;
			demid[m_NbrDlg].clkMove = false;
			DlgNbr++;
		}

		demid[m_NbrDlg].clkMove = !demid[m_NbrDlg].clkMove;

		if ((long)demid[m_NbrDlg].procDlg == 0) demid[m_NbrDlg].procDlg = (WNDPROC)SetWindowLong(m_dialog,GWL_WNDPROC,(long)procDlg);

		ret("S_OK");
	}
	MFUNC(GetClkMove)
	{
		if ((int)data[0] == NULL) ret("DATA_ERROR");

		//rcupration du HWND a partir du nom du dialog
		wsprintf(mData,"$dialog(%s).hwnd",data);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		int m_NbrDlg;
		m_NbrDlg = dlgFind((HWND)atol(mData));

		if ((m_NbrDlg == -1) || (!demid[m_NbrDlg].clkMove)) ret("$false");
		ret("$true");
	}

	MFUNC(ImgSizeX)
	{
		if ((int)data[0] == NULL) ret("DATA_ERROR");

		BMGImageStruct bmp;
		if (!ReadIMG(data,&bmp)) ret("IMAGE_NOT_LOAD");
		wsprintf(data,"%u",bmp.width);
		return 3;
	}
	MFUNC(ImgSizeY)
	{
		if ((int)data[0] == NULL) ret("DATA_ERROR");

		BMGImageStruct bmp;
		if (!ReadIMG(data,&bmp)) ret("IMAGE_NOT_LOAD");
		wsprintf(data,"%u",bmp.height);
		return 3;
	}
/*	MFUNC(ImgSave)
	{
		char ImgSrc[0xFF],ImgDest[0xFF];
		int j = 0,i = 0;
		while ((int)data[i] != 32)
		{
			if ((int)data[i] == NULL) ret("ERROR_DATA");
			ImgSrc[j] = data[i];
			i++;
			j++;
		}
		ImgSrc[i] = NULL;

		i++;
		j = 0;
		while (((int)data[i] != NULL) && ((int)data[i] != 32))
		{
			ImgDest[j] = data[i];
			j++;
			i++;
		}
		ImgDest[j] = NULL;
		j -= 4;

		//Vrification que ce caractre tombe bien sur un '.'
		if ((int)ImgDest[j] != 46) ret("ERROR_DATA");

		int a = 0;
		char ext[0xF];
		while (a <= 4) {
			ext[a] = ImgDest[j];
			a++;
			j++;
		}

		char c_compress[0xF];
		int m_compress;
		if ((int)data[i] == 32) {
			i++;
			j = 0;
			while ((int)data[i] != NULL)
			{
				c_compress[j] = data[i];
				j++;
				i++;
			}
			c_compress[j] = NULL;
			m_compress = atol(c_compress);
		}
		else m_compress = 80;
		if (m_compress > 100) ret("ERROR_DATA");

		BMGImageStruct bmp;
		if (!ReadIMG(ImgSrc,&bmp)) ret("IMAGE_NOT_LOAD");

		int result;
        if (lstrcmpi(ext,".jpg") == 0) result = WriteJPEG(ImgDest,bmp,m_compress);
		else if (lstrcmpi(ext,".png") == 0) result = WritePNG(ImgDest,bmp);
		else if (lstrcmpi(ext,".bmp") == 0) result = WriteBMP(ImgDest,bmp);
		else if (lstrcmpi(ext,".tif") == 0) result = WriteTIFF(ImgDest,bmp,NULL);
		else if (lstrcmpi(ext,".tga") == 0) result = WriteTGA(ImgDest,bmp);
		else ret("ERROR_DATA");

		if (result != 0) ret("IMAGE_NOT_SAVE");
		ret("S_OK");
	}
*/
	MFUNC(DlgParent)
	{
		char DlgName[0xFF],fenetre[0xFF],m_hwnd[0xFF];
		int j = 0,i = 0;
		while ((int)data[i] != 32)
		{
			if ((int)data[i] == NULL) ret("DATA_ERROR");
			DlgName[j] = data[i];
			i++;
			j++;
		}
		DlgName[i] = NULL;

		i++;
		j = 0;
		while (((int)data[i] != 32) && ((int)data[i] != NULL))
		{
			fenetre[j] = data[i];
			j++;
			i++;
		}
		fenetre[j] = NULL;

		if ((int)data[i] != NULL) i++;
		j = 0;
		while ((int)data[i] != NULL)
		{
			m_hwnd[j] = data[i];
			j++;
			i++;
		}
		m_hwnd[j] = NULL;

		wsprintf(mData,"$dialog(%s).hwnd",DlgName);
		SendMessage(mWnd,WM_USER + 201,0,0L);

		if (mData[0] == NULL) ret("DATA_ERROR");

		HWND m_dialog;
		m_dialog = (HWND)atol(mData);

		//cration du dialogue
		int m_NbrDlg;
		m_NbrDlg = dlgFind(m_dialog);

		if (m_NbrDlg == -1) {
			m_NbrDlg = dlgLibre();
			if (m_NbrDlg == -1) ret("MAXIMUM_LIMIT");
			demid[m_NbrDlg].dlgHwnd = m_dialog;
			demid[m_NbrDlg].dlgUsed = true;
			DlgNbr++;
		}

		demid[m_NbrDlg].dlgparent = true;

		if (lstrcmpi(fenetre,"HWND") == 0) {
			HWND hwnd;
			hwnd = (HWND)atol(m_hwnd);
			if (IsWindow(hwnd)) SetParent(m_dialog,hwnd);
			else ret("DATA_ERROR");

			if (hwnd == 0) demid[m_NbrDlg].dlgparent = false;
		}
		else if (lstrcmpi(fenetre,"SWITCHBAR") == 0) {
			HWND hwnd;
			hwnd = FindWindowEx(loadInfo.mHwnd,NULL,"mIRC_SwitchBar",NULL);
			if (hwnd != NULL) SetParent(m_dialog,hwnd);
			else ret("DATA_ERROR");
		}
		else if (lstrcmpi(fenetre,"TOOLBAR") == 0) {
			HWND hwnd;
			hwnd = FindWindowEx(loadInfo.mHwnd,NULL,"mIRC_Toolbar",NULL);
			if (hwnd != NULL) SetParent(m_dialog,hwnd);
			else ret("DATA_ERROR");
		}
		else if (lstrcmpi(fenetre,"EDIT") == 0) {
			HWND hwnd;
			//rcupration du HWND a partir du nom du window
			wsprintf(mData,"$window(%s).hwnd",m_hwnd);
			SendMessage(mWnd,WM_USER + 201,0,0L);
			if (mData[0] == NULL) ret("DATA_ERROR");
			hwnd = FindWindowEx((HWND)atol(mData),NULL,"Edit",NULL);
			if (hwnd != NULL) SetParent(m_dialog,hwnd);
			else ret("DATA_ERROR");
		}
		else if (lstrcmpi(fenetre,"STATIC") == 0) {
			HWND hwnd;
			//rcupration du HWND a partir du nom du window
			wsprintf(mData,"$window(%s).hwnd",m_hwnd);
			SendMessage(mWnd,WM_USER + 201,0,0L);
			if (mData[0] == NULL) ret("DATA_ERROR");
			hwnd = FindWindowEx((HWND)atol(mData),NULL,"Static",NULL);
			if (hwnd != NULL) SetParent(m_dialog,hwnd);
			else ret("DATA_ERROR");
		}
		else if (lstrcmpi(fenetre,"LISTBOX") == 0) {
			HWND hwnd;
			//rcupration du HWND a partir du nom du window
			wsprintf(mData,"$window(%s).hwnd",m_hwnd);
			SendMessage(mWnd,WM_USER + 201,0,0L);
			if (mData[0] == NULL) ret("DATA_ERROR");
			hwnd = FindWindowEx((HWND)atol(mData),NULL,"ListBox",NULL);
			if (hwnd != NULL) SetParent(m_dialog,hwnd);
			else ret("DATA_ERROR");
		}

		else ret("DATA_ERROR");

		ret("S_OK");
	}
}